var $ = jQuery;
$(function() {
    var subjectOld = $("input.InputSubject").val();
    var gradeOld = $("select.SelectDisGrade").val();
    var bonusOld = $("input.BonusRate").prop("checked");
    var controlOld = $("input.ExamType").filter(":checked");
    
    var lectionCount = parseInt($("input.InputLectureCount").val());
    var labCount = parseInt($("input.InputLabCount").val());
    var practiceCount = parseInt($("input.InputPracticeCount").val());


    // Изменения базовых параметров дисциплины
    $("select.SelectSubject").select2({allowClear: false});
    
    // Изменение предмета
    $("select.SelectSubject").change(function()
    {
        var jThis = $(this);
        $.post(
            g_URLdir + "handler/map/ChangeDisciplineSubject",
            {
                "DisciplineID": g_disciplineID,
                "SubjectID": jThis.val()
            },
            function(data) 
            {
                data = $.parseJSON(data);
                if(data.success === true) {
                    subjectOld = jThis.val();
                }
                else { 
                    EventInspector.error("Ошибка: Изменение предмета");
                    jThis.val(subjectOld);
                }
            }
        );
    });
    
    // Изменение курса
    $("select.SelectDisGrade").change(function()
    { // SelectGrade совпадает с другим, поэтому SelectDisGrade
        var jThis = $(this);
        jThis.prop("disabled", true);
        $.post(
            g_URLdir + "handler/map/ChangeDisciplineGrade",
            {
                "DisciplineID": g_disciplineID,
                "GradeID": jThis.val(),
                "SubjectID": $("select.SelectSubject").val()
            },
            function(data)
            {
                data = $.parseJSON(data);
                if(data.success === true) {
                    gradeOld = jThis.val();
                }
                else {
                    jThis.val(gradeOld);

                    if (parseInt(data.code) === 1)
                        EventInspector.error("Дисциплина с таким курсом уже существует");
                    else
                        EventInspector.error("Ошибка при изменении курса");
                }
                jThis.removeAttr("disabled");
            }
            
        );
    });
    
    // Бонусные баллы
    $("input.BonusRate").change(function()
    {
        var jThis = $(this);
        jThis.attr("disabled", true);
        $.post(
            g_URLdir + "handler/map/ChangeStatusBonusModule",
            {
                "DisciplineID": g_disciplineID,
                "BonusRate": $(this).prop("checked")
            },
            function(data) {
                data = $.parseJSON(data);
                if(data.success === true) {
                    bonusOld = jThis.prop("checked");
                }
                else {
                    // var message = (data.action == "add")?   "Бонусные баллы добавлены"
                    //                                     :   "Бонусные баллы удалены";
                    EventInspector.error("Ошибка: Бонусные баллы");
                    jThis.prop("checked", bonusOld);
                }
                jThis.removeAttr("disabled");
            }
        );
    });
    
    // Изменение контроля
    $("input.ExamType").change(function()
    {
        var jThis = $(this);
        var list = jThis.siblings("input.ExamType");
        list.attr("disabled", true);
        $.post(
            g_URLdir + "handler/map/ChangeDisciplineControl",
            {
                "DisciplineID": g_disciplineID,
                "Control": jThis.val()
            },
            function(data) {
                data = $.parseJSON(data);
                var status = parseInt(data.success);
                if(status === 0) {
                    controlOld = jThis;
                }
                else { 
                    controlOld.prop("checked", true);
                    if (status > 0)
                        EventInspector.error("Превышено максимальное кол-во баллов");    
                    else 
                        EventInspector.error("Ошибка: Изменение формы контроля");
                }
                list.removeAttr("disabled");
            }
        );
    });
    

    LessonType = {
        Practice:   "0",
        Lection:    "1",
        Lab: "2"
    };

    // Изменение лекционных часов
    $("input.InputLectureCount").focusout(function()
    {
        var jThis = $(this);
        var value = parseInt($(this).val());
        if (value === lectionCount)
            return;

        $(this).prop("disabled", true);
        $.post(
            g_URLdir + "handler/map/ChangeDisciplineHours",
            {
                "DisciplineID": g_disciplineID,
                "Hours": value,
                "Type": LessonType.Lection
            },
            function(data) 
            {
                data = $.parseJSON(data);
                if(data.success === true) {
                    lectionCount = value;
                }
                else {
                    if (data.result_code === -2) {
                        EventInspector.error("Часы может изменить только автор дисциплины");
                    } else {
                        EventInspector.error("Ошибка: Изменение лекционных часов");
                    }
                    jThis.val(LectionCount);
                }

                jThis.removeAttr("disabled");
            }
        );
    })
    .keydown(function(event) {
        keyDownOnlyNumber(event);
    });

    // Изменение лабораторных часов
    $("input.InputLabCount").focusout(function()
    {
        var jThis = $(this);
        var value = parseInt(jThis.val());
        if (value === labCount)
            return;

        $(this).prop("disabled", true);
        $.post(
            g_URLdir + "handler/map/ChangeDisciplineHours",
            {
                "DisciplineID": g_disciplineID,
                "Hours": value,
                "Type": LessonType.Lab
            },
            function(data) 
            {
                data = $.parseJSON(data);
                if(data.success === true) {
                    labCount = value;
                }
                else {
                    if (data.result_code === -2) {
                        EventInspector.error("Часы может изменить только автор дисциплины");
                    } else {
                        EventInspector.error("Ошибка: Изменение лабораторных часов");
                    }
                    jThis.val(labCount);
                }

                jThis.removeAttr("disabled");
            }
        );
    })
    .keydown(function(event) {
        keyDownOnlyNumber(event);
    });
    
    // Изменение практических часов
    $("input.InputPracticeCount").focusout(function()
    {
        var jThis = $(this);
        var value = parseInt(jThis.val());
        if (value === practiceCount)
            return;
        $(this).prop("disabled", true);
        $.post(
            g_URLdir + "handler/map/ChangeDisciplineHours",
            {
                "DisciplineID": g_disciplineID,
                "Hours": value,
                "Type": LessonType.Practice
            },
            function(data) 
            {
                data = $.parseJSON(data);
                if(data.success === true) {
                    practiceCount = value;
                }
                else {
                    jThis.val(practiceCount);
                    if (data.result_code === -2) {
                        EventInspector.error("Часы может изменить только автор дисциплины");
                    } else {
                        EventInspector.error("Ошибка: Изменение практических часов");
                    }
                }

                jThis.removeAttr("disabled");
            }
        );
    })
    .keydown(function(event) {
        keyDownOnlyNumber(event);
    });
    
});
